'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _takeDefaultOptions = require('../lib/takeDefaultOptions');

var _takeDefaultOptions2 = _interopRequireDefault(_takeDefaultOptions);

var _medalPopup = require('../components/Medal/medalPopup');

var _medalPopup2 = _interopRequireDefault(_medalPopup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created by sorgog on 2018/12/23.
 */
var $vm = void 0;

exports.default = {
  install: function install(Vue) {
    var MedalPopup = Vue.extend(_medalPopup2.default);

    if (!$vm) {
      $vm = new MedalPopup({
        el: document.createElement('div')
      });
      document.body.appendChild($vm.$el);
    }

    var defaults = (0, _takeDefaultOptions2.default)($vm);

    Vue.$MedalPopup = {
      show: function show() {
        var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        options = (0, _assign2.default)({}, defaults, options);
        for (var i in options) {
          if (options.hasOwnProperty(i)) {
            $vm[i] = options[i];
          }
        }

        $vm.$off('hide');
        $vm.$on('hide', function () {
          options && options.onHide && options.onHide();
          $vm.visible = false;
        });

        $vm.visible = true;
      },
      hide: function hide() {
        $vm.visible = false;
      }
    };

    Vue.mixin({
      created: function created() {
        this.$MedalPopup = Vue.$MedalPopup;
      }
    });
  }
};