'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _takeDefaultOptions = require('../lib/takeDefaultOptions');

var _takeDefaultOptions2 = _interopRequireDefault(_takeDefaultOptions);

var _ZuicoolConfirm = require('../components/ZuicoolConfirm');

var _ZuicoolConfirm2 = _interopRequireDefault(_ZuicoolConfirm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created by LiH on 2018/01/12.
 */
var $vm = void 0;

var plugin = {
  install: function install(Vue, options) {
    var Alert = Vue.extend(_ZuicoolConfirm2.default);

    if (!$vm) {
      $vm = new Alert({
        el: document.createElement('div')
      });
      document.body.appendChild($vm.$el);
    }

    var defaults = (0, _takeDefaultOptions2.default)($vm);

    Vue.$ZCConfirm = {
      show: function show() {
        var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        if (typeof options === 'string') {
          $vm.text = options;
        } else if ((typeof options === 'undefined' ? 'undefined' : (0, _typeof3.default)(options)) === 'object') {
          options = (0, _assign2.default)({}, defaults, options);
          for (var i in options) {
            if (options.hasOwnProperty(i)) {
              $vm[i] = options[i];
            }
          }
        }
        $vm.$off('cancel');
        $vm.$off('confirm');
        $vm.$off('hide');
        $vm.$on('cancel', function () {
          options && options.onCancel && options.onCancel();
        });
        $vm.$on('confirm', function () {
          options && options.onConfirm && options.onConfirm();
        });
        $vm.$on('hide', function () {
          options && options.onHide && options.onHide();
          $vm.visible = false;
        });
        $vm.visible = true;
      },
      hide: function hide() {
        $vm.visible = false;
      }
    };

    Vue.mixin({
      created: function created() {
        this.$ZCConfirm = Vue.$ZCConfirm;
      }
    });
  }
};

exports.default = plugin;