'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ZuicoolGuideMask = require('../components/ZuicoolGuideMask');

var _ZuicoolGuideMask2 = _interopRequireDefault(_ZuicoolGuideMask);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var $vm = void 0; /**
                   * Created by LiH on 2018/5/17.
                   */
exports.default = {
  install: function install(Vue) {
    var GuideMask = Vue.extend(_ZuicoolGuideMask2.default);

    if (!$vm) {
      $vm = new GuideMask({
        el: document.createElement('div')
      });
      document.body.appendChild($vm.$el);
    }

    Vue.$ZCGuideMask = {
      show: function show(frames, el) {
        if (frames instanceof Array) {
          if (!frames.length) {
            throw new Error('ZCGuideMask: frames can not be empty');
          } else if (frames.some(function (frame) {
            return !frame.window;
          })) {
            throw new Error('ZCGuideMask: every frame should have window prop');
          } else {
            $vm.step = 0;
            $vm.frames = frames;
          }
        } else {
          throw new TypeError('ZCGuideMask: frames must be an array');
        }

        // 移动$el会导致取不到$ZCGuideMask
        if (el && (el instanceof HTMLElement || el.nodeType === 1)) {
          console.log('el:' + el);
          el.appendChild($vm.$el);
        }

        $vm.visible = true;
      },
      hide: function hide() {
        $vm.$el.style.position = 'fixed';
        document.body.appendChild($vm.$el);
        $vm.visible = false;
        return $vm.$el;
      }
    };

    Vue.mixin({
      created: function created() {
        this.$ZCGuideMask = Vue.$ZCGuideMask;
      }
    });
  }
};