'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _takeDefaultOptions = require('../lib/takeDefaultOptions');

var _takeDefaultOptions2 = _interopRequireDefault(_takeDefaultOptions);

var _ZuicoolLoading = require('../components/ZuicoolLoading');

var _ZuicoolLoading2 = _interopRequireDefault(_ZuicoolLoading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created by LiH on 2018/7/10.
 */
var $vm = void 0;

exports.default = {
  install: function install(Vue) {
    var Loading = Vue.extend(_ZuicoolLoading2.default);

    if (!$vm) {
      $vm = new Loading({
        el: document.createElement('div')
      });
      document.body.appendChild($vm.$el);
    }

    var defaults = (0, _takeDefaultOptions2.default)($vm);

    // fade out animation setTimeout
    var fadeOut = null;

    Vue.$ZCLoading = {
      show: function show() {
        var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        options = (0, _assign2.default)({}, defaults, options, { show: true });
        for (var i in options) {
          if (options.hasOwnProperty(i)) {
            $vm[i] = options[i];
          }
        }

        if (fadeOut) {
          clearTimeout(fadeOut);
          fadeOut = null;
          $vm.$el.style.transition = '';
          $vm.$el.style.opacity = 1;
        }
        $vm.visible = true;
      },
      hide: function hide() {
        var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        if (options.fadeOut) {
          var _elm = $vm.$el;

          _elm.style.transition = 'opacity .5s';
          _elm.style.opacity = 0;
          fadeOut = setTimeout(function () {
            _elm.style.transition = '';
            _elm.style.opacity = 1;
            $vm.visible = false;
          }, 500);
        } else {
          $vm.visible = false;
        }
      }
    };

    Vue.mixin({
      created: function created() {
        this.$ZCLoading = Vue.$ZCLoading;
      }
    });
  }
};