'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WX_showMenuItemToShare = exports.WX_hideAllMenuItem = exports.WX_configShare = exports.WX_verify = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _axios = require('../plugins/axios');

var _weixinJsSdk = require('weixin-js-sdk');

var _weixinJsSdk2 = _interopRequireDefault(_weixinJsSdk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created by LiH on 2018/7/19.
 */
function _verifyFailed(_ref) {
  var errMsg = _ref.errMsg,
      message = _ref.message;

  Vue.$vux.toast.text('\u5FAE\u4FE1\u63A5\u53E3\u8BA4\u8BC1\u5931\u8D25:\n' + (errMsg || message), 'bottom');

  console.error('WX_verifyFailed:\n' + (errMsg || message));
}

function _takeVerifyConf() {
  var HOST = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  return _axios.request.get(HOST + '/ApiService/weixin/signature', {
    params: {
      url: window.location.href.split('#')[0]
    }
  });
}

function _config(_ref2) {
  var APP_ID = _ref2.APP_ID,
      timestamp = _ref2.timestamp,
      nonceStr = _ref2.nonceStr,
      signature = _ref2.signature;

  _weixinJsSdk2.default.config({
    debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
    appId: APP_ID, // 必填，公众号的唯一标识
    timestamp: timestamp, // 必填，生成签名的时间戳
    nonceStr: nonceStr, // 必填，生成签名的随机串
    signature: signature, // 必填，签名，见附录1
    jsApiList: [
    // 语音接口
    'startRecord', 'stopRecord', 'onVoiceRecordEnd', 'uploadVoice', 'downloadVoice', 'playVoice', 'pauseVoice', 'onVoicePlayEnd',
    // 分享接口
    'onMenuShareTimeline', 'onMenuShareAppMessage', 'onMenuShareQQ', 'hideMenuItems', 'showMenuItems',
    // 图片接口
    'downloadImage', 'chooseImage', 'uploadImage', 'getLocalImgData'],
    fail: _verifyFailed
  });
}

function _wxConfig(data) {
  if (typeof window.WeixinJSBridge !== 'undefined') {
    _config(data);
  } else {
    document.addEventListener('WeixinJSBridgeReady', function listener() {
      document.removeEventListener('WeixinJSBridgeReady', listener);
      _config(data);
    });
  }
}

function WX_verify(APP_ID, HOST) {
  if (typeof APP_ID !== 'undefined') {
    return _takeVerifyConf(HOST).then(function (_ref3) {
      var data = _ref3.data.result.data;

      _wxConfig((0, _extends3.default)({
        APP_ID: APP_ID
      }, data));
    }).catch(_verifyFailed);
  }
  return _promise2.default.reject('WX_verify: APP_ID not exist');
}

function WX_hideAllMenuItem() {
  _weixinJsSdk2.default.hideMenuItems({
    menuList: [
    // 保护类
    /*'menuItem:copyUrl', */'menuItem:openWithQQBrowser', 'menuItem:openWithSafari', 'menuItem:share:email', 'menuItem:readMode',
    // 传播类
    'menuItem:share:appMessage', 'menuItem:share:timeline', 'menuItem:share:qq', 'menuItem:share:weiboApp', 'menuItem:favorite', 'menuItem:share:facebook', 'menuItem:share:QZone']
  });
}

function WX_showMenuItemToShare() {
  _weixinJsSdk2.default.showMenuItems({
    menuList: ['menuItem:share:appMessage', 'menuItem:share:timeline', 'menuItem:favorite']
  });
}

/**
 * 分享config
 * @param config {link, title, desc, imgUrl}
 */
function WX_configShare(config) {
  _weixinJsSdk2.default.onMenuShareAppMessage(config);
  _weixinJsSdk2.default.onMenuShareTimeline(config);
}

exports.WX_verify = WX_verify;
exports.WX_configShare = WX_configShare;
exports.WX_hideAllMenuItem = WX_hideAllMenuItem;
exports.WX_showMenuItemToShare = WX_showMenuItemToShare;